clear all
clc
ant=1;
Noe=1; %5 5 7 13 case 3
for i=1:Noe
    Ne(i)=200;
    Length(i)=1/Noe;
end
sum(Length)

StartE=zeros(Noe,1);
for i=2:Noe
    StartE(i)=StartE(i-1)+Length(i-1);
end


for i=1:Noe
[rE{i},wE{i}]=GaussLobattoLegendre(Ne(i));
DE{i}=LagrangeDerivativeMatrix_GLL(Ne(i));
%[rE{i} DE{i} BDE{i} qE{i}] = colloc(Ne(i)-2,1,1);
%mapping
rE{i}=(rE{i}/2+0.5)*Length(i)+StartE(i);
DE{i}=DE{i}*2/Length(i);
wE{i}=wE{i}/2*Length(i);
end
%total number of points:
Npoints=sum(Ne)-max(size(Ne))+1;
N=Npoints

%cumulative addition of elements:
Nec=ones(Noe+1,1);
Nec(2)=Ne(1);
for i=2:Noe
    Nec(i+1)=Nec(i)+Ne(i)-1;
end

Neb=ones(Noe+1,1);
%Nec(2)=Ne(1);
for i=1:Noe
    Neb(i+1)=Neb(i)+Ne(i);
end

Necspace=Nec-1;
Nebspace=Neb-1;
Nebspace(1)=0;
% r vector for solution:
r=zeros(N,1);
for E=1:Noe
r(Nec(E):Nec(E+1))=rE{E};
end
% calulate weights
wlign=zeros(N,1);
wmatrix=zeros(sum(Ne),1);
for E=1:Noe
wlign(Nec(E):Nec(E+1),1)=wlign(Nec(E):Nec(E+1),1)+wE{E};
wmatrix(Neb(E):Neb(E+1)-1,1)=wmatrix(Neb(E):Neb(E+1)-1,1)+wE{E};
end

 WGT=[];
 Wmatrix=[];
 for i=1:ant
     WGT=[WGT;wlign];
     Wmatrix=[Wmatrix;wmatrix];
 end
 Wmatrix=diag(Wmatrix);



ant=1;%antall ligninger

tol=1*10^-15;
tetta=0.5;
tstep=1*10^-3;
t=0;
v=1
rhotst=0.1*ones(N,1);
rhotst(1)=1;
residual=1
f=ones(N,1);
frame=0;
figure
while t<0.25
   t=t+tstep
   residual=1;
   frame=frame+1;
while residual>tol %&& itcount <250
    %automatic for elements:
    R=zeros(sum(Ne),ant*sum(Ne),ant);
    Nlsq=sum(Ne);
    %Neb(end)=sum(Ne);
    for E=1:Noe
        %initspace=zeros(Ne(i),Necspace(i));
        SEEND=zeros(Ne(E),Neb(end)-Neb(E+1));
        SESTART=zeros(Ne(E),Nebspace(E));
        
        R(Neb(E):Neb(E+1)-1,:,1)=R(Neb(E):Neb(E+1)-1,:,1)  +[SESTART,diag(ones(Ne(E),1))+DE{E}*v*tstep*tetta,SEEND];
   end

A=zeros(ant*N,ant*N);
     L=[R(:,:,1)];
     
     Anonoverlapping=L'*Wmatrix*L;
     
     %introduce overlap:
     for E=1:Noe
         for i=1:ant
             for j=1:ant
                A((N*(j-1)+Nec(E):N*(j-1)+Nec(E+1)),(N*(i-1)+Nec(E):N*(i-1)+Nec(E+1)))=A((N*(j-1)+Nec(E):N*(j-1)+Nec(E+1)),(N*(i-1)+Nec(E):N*(i-1)+Nec(E+1)))+Anonoverlapping((sum(Ne)*(j-1)+Neb(E):sum(Ne)*(j-1)+Neb(E+1)-1),(sum(Ne)*(i-1)+Neb(E):sum(Ne)*(i-1)+Neb(E+1)-1));
             end
         end 
     end


%Boundary conditions in A matrix:
A(1,1)=A(1,1)+1;

g=zeros(sum(Ne),ant);
for E=1:Noe
g(Neb(E):Neb(E+1)-1,1)=tstep*(1-tetta)*-DE{E}*rhotst(Nec(E):Nec(E+1))*v+rhotst(Nec(E):Nec(E+1));
end
gV=[];
for i=1:ant
    gV=[gV;g(:,i)];
end
Fw=L'*Wmatrix*gV;
F=zeros(N*ant,1);
for I=1:ant
for E=1:Noe
F(N*(I-1)+Nec(E):N*(I-1)+Nec(E+1),1)=F(N*(I-1)+Nec(E):N*(I-1)+Nec(E+1),1)+Fw((Neb(E):Neb(E+1)-1)+sum(Ne)*(I-1),1);
end
end

F(1)=F(1)+1;

fold=f;


%solve
f=A\F;

residual=sqrt((A*f-F)'*diag(WGT)*(A*f-F))

end
plot(r,f);
xlim([0 1]) 
% M(frame)=getframe
gif_add_frame(gca,'LSQExplisittEULER.gif',30);
% pause
rhotst=f(1:N);
end

