fig
screen_size = get(0, 'ScreenSize');
f1 = figure(1);
set(f1, 'Position', [1 4 30 16.875 ] );
subaxis(3,3,1,'SpacingVert',0.12,'SpacingHoriz',0.08,'MarginRight',0.02,'MarginLeft',0.071,'MarginTop',0.05,'MarginBottom',0.07);
hold on
plot(r,f(0*N+1:1*N)*Tref,'--r','LineWidth',2)
for i=1:2
subaxis(3,3,1+i);
hold on
plot(r,Y(:,i),'--r','LineWidth',2)
end

for i=3:5
subaxis(3,3,1+i);
hold on
plot(r,Y(:,i),'--r','LineWidth',2)
end

for i=6:6
subaxis(3,3,1+i);
hold on
plot(r,Y(:,i),'--r','LineWidth',2)
end
subaxis(3,3,8);
hold on
plot(r,v*vref,'--r','LineWidth',2)
subaxis(3,3,9);
hold on
plot(r,Pl*Pic,'--r','LineWidth',2)


%legends
subaxis(3,3,1,'SpacingVert',0.12,'SpacingHoriz',0.08,'MarginRight',0.02,'MarginLeft',0.071,'MarginTop',0.05,'MarginBottom',0.07);
box off
title('Temperature')
xlabel('Position in reactor[m]')
ylabel('Temperature[K]')
subaxis(3,3,2);
box off
title('CH4')
xlabel('Position in reactor[m]')
ylabel('Molefraction[-]')
subaxis(3,3,3);
box off
title('CO')
xlabel('Position in reactor[m]')
ylabel('Molefraction[-]')
subaxis(3,3,4);
box off
title('CO2')
xlabel('Position in reactor[m]')
ylabel('Molefraction[-]')
subaxis(3,3,5);
box off
title('H2')
xlabel('Position in reactor[m]')
ylabel('Molefraction[-]')
subaxis(3,3,6);
box off
title('N2')
xlabel('Position in reactor[m]')
ylabel('Molefraction[-]')
subaxis(3,3,7);
box off
title('H2O')
xlabel('Position in reactor[m]')
ylabel('Molefraction[-]')
subaxis(3,3,8);
box off
title('Mass av. velocity')
xlabel('Position in reactor[m]')
ylabel('Velocity[m/s]')
subaxis(3,3,9);
box off
title('Pressure')
xlabel('Position in reactor[m]')
ylabel('Pressure[pa]')