Fluxplot=Flux*RHOref*Dref/Rp;
for i=1:6
    Fluxplot(:,i)=Fluxplot(:,i)/MMASS(i);
end
fig
f1 = figure(1);
%set(f1, 'Position', [0 0 screen_size(3) screen_size(4) ] );
set(f1, 'Position', [1 4 30 15.25 ] );
for i=1:3
subaxis(2,3,i,'SpacingVert',0.15,'SpacingHoriz',0.08,'MarginRight',0.05,'MarginLeft',0.08,'MarginTop',0.08,'MarginBottom',0.1);
hold on
plot(r,Fluxplot(:,i),'+')
end

for i=4:6
subaxis(2,3,i);
hold on
plot(r,Fluxplot(:,i),'+')
end

% for i=6:6
% subaxis(2,3,i,'Spacing', 0.02, 'Padding', 0.036, 'Margin', 0, 'MarginBottom',.01);
% hold on
% plot(r,Flux(:,i),'-')
% end

%legends
subaxis(2,3,1,'SpacingVert',0.15,'SpacingHoriz',0.08,'MarginRight',0.05,'MarginLeft',0.08,'MarginTop',0.08,'MarginBottom',0.1);
box off
title('CH4')
xlabel('Position in particle[m]')
ylabel('Flux[kmol/s m2]')
subaxis(2,3,2);
box off
title('CO')
xlabel('Position in particle[m]')
ylabel('Flux[kmol/s m2]')
subaxis(2,3,3);
box off
title('CO2')
xlabel('Position in particle[m]')
ylabel('Flux[kmol/s m2]')
subaxis(2,3,4);
box off
title('H2')
xlabel('Position in particle[m]')
ylabel('Flux[kmol/s m2]')
subaxis(2,3,5);
box off
title('N2')
xlabel('Position in particle[m]')
ylabel('Flux[kmol/s m2]')
subaxis(2,3,6);
box off
title('H2O')
xlabel('Position in particle[m]')
ylabel('Flux[kmol/s m2]')