
Cau=zeros(N,6);
for i=1:6
    Cau(:,i)=C.*Y(:,i).*u*Dref/Rp;
end
Fluxplott=Flux*Cref*Dref/Rp+Cau;
fig
screen_size = get(0, 'ScreenSize');
set(f1,'position',[0 5 55 20 ]);
f1 = figure(1);
for i=1:3
subaxis(2,3,i,'Spacing', 0.02, 'Padding', 0.036, 'Margin', 0, 'MarginBottom',.03);
hold on
plot(r,Fluxplott(:,i),'r')
end

for i=4:6
subaxis(2,3,i,'Spacing', 0.02, 'Padding', 0.036, 'Margin', 0, 'MarginBottom',.03, 'MarginTop',.03);
hold on
plot(r,Fluxplott(:,i),'r')
end

% for i=6:6
% subaxis(2,3,i,'Spacing', 0.02, 'Padding', 0.036, 'Margin', 0, 'MarginBottom',.01);
% hold on
% plot(r,Flux(:,i),'-')
% end

%legends
subaxis(2,3,1,'Spacing', 0.02, 'Padding', 0.036, 'Margin', 0, 'MarginBottom',.03);
box off
title('CH4')
xlabel('Position in particle[m]')
ylabel('Flux[kmol/s m2]')
subaxis(2,3,2,'Spacing', 0.02, 'Padding', 0.036, 'Margin', 0, 'MarginBottom',.03);
box off
title('CO')
xlabel('Position in particle[m]')
ylabel('Flux[kmol/s m2]')
subaxis(2,3,3,'Spacing', 0.02, 'Padding', 0.036, 'Margin', 0, 'MarginBottom',.03);
box off
title('CO2')
xlabel('Position in particle[m]')
ylabel('Flux[kmol/s m2]')
subaxis(2,3,4,'Spacing', 0.02, 'Padding', 0.036, 'Margin', 0, 'MarginBottom',.03, 'MarginTop',.03);
box off
title('H2')
xlabel('Position in particle[m]')
ylabel('Flux[kmol/s m2]')
subaxis(2,3,5,'Spacing', 0.02, 'Padding', 0.036, 'Margin', 0, 'MarginBottom',.03, 'MarginTop',.03);
box off
title('N2')
xlabel('Position in particle[m]')
ylabel('Flux[kmol/s m2]')
subaxis(2,3,6,'Spacing', 0.02, 'Padding', 0.036, 'Margin', 0, 'MarginBottom',.03, 'MarginTop',.03);
box off
title('H2O')
xlabel('Position in particle[m]')
ylabel('Flux[kmol/s m2]')