clear all
clc
for i=1:1
Comp=i;
for j=1:1
CONVswitch=j;
for k=1:1
Tlswitch=k;
for l=3:4
diffmodel=l;
tic
global N  GASCONST MMASS

%For loops:
% i = main component
% j = secondary component
% k = position in particle

%convective on off
% ConvSWITCH=1;% on=1 off=0

%BC - transfer limitations on off
% TlSWITCH=1;

%Diffusion model
% DIFFmodel=1;
%1=Wilke
%2=Wilke Bosanquet
%3=MS
%4=Dusty gas

%component solved by 1-sum(N-1)
% CompSOLV=1;
%1=CH4
%2=CO2
%3=CO
%4=H2
%5=N2
%6=H2O


ant=17;%equations in the main matrix
    %ELEMENT ROUTINE:
Noe=4; %5 5 7 13 case 3
Ne(1)=3; %14
Ne(2)=3;  %8
Ne(3)=5;
Ne(4)=25;
% Ne(5)=6;
% Ne(6)=6;
% Ne(7)=6;
% Ne(8)=6;
% Ne(9)=20;


Length(1)=0.78;
Length(2)=0.06;
Length(3)=0.04;
Length(4)=0.12;
% Length(5)=0.04;
% Length(6)=0.03;
% Length(7)=0.02;
% Length(8)=0.01;
% Length(9)=0.09;
sum(Length)

StartE=zeros(Noe,1);
for i=2:Noe
    StartE(i)=StartE(i-1)+Length(i-1);
end


for i=1:Noe
[rE{i},wE{i}]=GaussLobattoLegendre(Ne(i));
DE{i}=LagrangeDerivativeMatrix_GLL(Ne(i));
%[rE{i} DE{i} BDE{i} qE{i}] = colloc(Ne(i)-2,1,1);
%mapping
rE{i}=(rE{i}/2+0.5)*Length(i)+StartE(i);
DE{i}=DE{i}*2/Length(i);
wE{i}=wE{i}/2*Length(i);
end
%total number of points:
Npoints=sum(Ne)-max(size(Ne))+1;
N=Npoints

%cumulative addition of elements:
Nec=ones(Noe+1,1);
Nec(2)=Ne(1);
for i=2:Noe
    Nec(i+1)=Nec(i)+Ne(i)-1;
end

Neb=ones(Noe+1,1);
%Nec(2)=Ne(1);
for i=1:Noe
    Neb(i+1)=Neb(i)+Ne(i);
end

Necspace=Nec-1;
Nebspace=Neb-1;
Nebspace(1)=0;
% r vector for solution:
r=zeros(N,1);
for E=1:Noe
r(Nec(E):Nec(E+1))=rE{E};
end
% calulate weights
wlign=zeros(N,1);
wmatrix=zeros(sum(Ne),1);
for E=1:Noe
wlign(Nec(E):Nec(E+1),1)=wlign(Nec(E):Nec(E+1),1)+wE{E};
wmatrix(Neb(E):Neb(E+1)-1,1)=wmatrix(Neb(E):Neb(E+1)-1,1)+wE{E};
end

 WGT=[];
 Wmatrix=[];
 for i=1:ant
     WGT=[WGT;wlign];
     Wmatrix=[Wmatrix;wmatrix];
 end
 Wmatrix=diag(Wmatrix);
%%%%%%%%%%S

%load constants:
    if Comp==1
        constantH2O
    elseif Comp==2
        constantCH4
    elseif Comp==3
        constantCO
    elseif Comp==4
        constantCO2
    elseif Comp==5
        constantH2
    elseif Comp==6
        constantN2
    end

    % r vector for solution:
r=zeros(Npoints,1);
for E=1:Noe
r(Nec(E):Nec(E+1))=rE{E};
end
% r=r*Rp;

f=[ones(N,1);zeros(N,1);... %temperature and
    %Species balance
  ones(N,1)*Yic(1);ones(N,1)*Yic(2);ones(N,1)*Yic(3);...
  ones(N,1)*Yic(4);ones(N,1)*Yic(5);ones(N,1)*Yic(6);...
%Fluxes
  zeros(N,1);zeros(N,1);zeros(N,1);zeros(N,1);zeros(N,1);zeros(N,1);...
    %Ideal gas law, Continuity, Darcys law
  ones(N,1);ones(N,1)*10^-6;ones(N,1)];

%preload variables freom IC vector:
Flux=[f(8*N+1:9*N),f(9*N+1:10*N),f(10*N+1:11*N),f(11*N+1:12*N),f(12*N+1:13*N),f(13*N+1:14*N)];
Y=[f(2*N+1:3*N),f(3*N+1:4*N),f(4*N+1:5*N),f(5*N+1:6*N),f(6*N+1:7*N),f(7*N+1:8*N)];
T=f(1:N)*Tref;
Cl=f(14*N+1:15*N);
u=f(15*N+1:16*N);
Pl=f(16*N+1:17*N);

fold=f;

%inital molefractions
Y=[f(2*N+1:3*N),f(3*N+1:4*N),f(4*N+1:5*N),f(5*N+1:6*N),f(6*N+1:7*N),f(7*N+1:8*N)];

% ant=17;%equations in the main matrix

%define weights for error calculation:
% w=[];
% for i=1:ant
%     we=zeros(N,1);
%     for E=1:Noe
%     we(Nec(E):Nec(E+1))=we(Nec(E):Nec(E+1))+qE{E};
%     end
%     w=[w;we];
% end

for E=1:Noe
DCvelconvRelaxedE{E}=zeros(Ne(E));
end

DELTAHr=zeros(N,1);
Rcomp=zeros(N,6);
ftrans=f;
t=0;
Cl=ones(N,1);
tpoints=0;
%Transient Loop:
while t<1
        if t<0.4
    tstep=5*10^-3;
    else
    tstep=0.1;    
    end
    t=t+tstep;
    tetta=0.5;
    Cltst=Cl;
    utst=u*CONVswitch;
    vtst=vconvrelaxed*CONVswitch;
    Ttst=T;
    Ytst=Y;
    Fluxtst=Flux;
    DELTAHrtst=DELTAHr;
    Rcomptst=Rcomp;
    CPgtst = Heat_capacity(Ytst(:,1),Ytst(:,2),Ytst(:,3),Ytst(:,4),Ytst(:,5),Ytst(:,6),Ttst);
    qtst=f(N+1:2*N);
fold=f;
Pulse=1;
residual=1;
tol=1*10^-8;
% Main Loop
while residual>tol %&& itcount <500
    u=u*CONVswitch;
       %change position for the automatic reaction H20 N2
   
    if Comp==2%CH4
    Yc=[Y(:,6),Y(:,2),Y(:,3),Y(:,4),Y(:,1),Y(:,5)];
    %calculate reaction rate and heat, Constant pressure
    [Rcomp,DELTAHr] = reaction(T,Yc,Pic*Pl); 
    %change order of components
    Rcomp=[Rcomp(:,5),Rcomp(:,2),Rcomp(:,3),Rcomp(:,4),Rcomp(:,6),Rcomp(:,1)];
    
    elseif Comp==3%CO
    Yc=[Y(:,1),Y(:,6),Y(:,3),Y(:,4),Y(:,2),Y(:,5)];
    %calculate reaction rate and heat, Constant pressure
    [Rcomp,DELTAHr] = reaction(T,Yc,Pic*Pl); 
    %change order of components
    Rcomp=[Rcomp(:,1),Rcomp(:,5),Rcomp(:,3),Rcomp(:,4),Rcomp(:,6),Rcomp(:,2)];
    
    elseif Comp==4%CO2
    Yc=[Y(:,1),Y(:,2),Y(:,6),Y(:,4),Y(:,3),Y(:,5)];
    %calculate reaction rate and heat, Constant pressure
    [Rcomp,DELTAHr] = reaction(T,Yc,Pic*Pl); 
    %change order of components
    Rcomp=[Rcomp(:,1),Rcomp(:,2),Rcomp(:,5),Rcomp(:,4),Rcomp(:,6),Rcomp(:,3)];
    
    elseif Comp==5%H2
    Yc=[Y(:,1),Y(:,2),Y(:,3),Y(:,6),Y(:,4),Y(:,5)];
    %calculate reaction rate and heat, Constant pressure
    [Rcomp,DELTAHr] = reaction(T,Yc,Pic*Pl); 
    %change order of components
    Rcomp=[Rcomp(:,1),Rcomp(:,2),Rcomp(:,3),Rcomp(:,5),Rcomp(:,6),Rcomp(:,4)];
    
    elseif Comp==1 %H2O
    Yc=[Y(:,1),Y(:,2),Y(:,3),Y(:,4),Y(:,6),Y(:,5)]; 
    %calculate reaction rate and heat, Constant pressure
    [Rcomp,DELTAHr] = reaction(T,Yc,Pic*Pl); 
    %change order of components
    Rcomp=[Rcomp(:,1),Rcomp(:,2),Rcomp(:,3),Rcomp(:,4),Rcomp(:,6),Rcomp(:,5)];
    
    elseif Comp==6 %N2
    %change position for the automatic reaction H20 N2
    Yc=[Y(:,1),Y(:,2),Y(:,3),Y(:,4),Y(:,5),Y(:,6)];
    %calculate reaction rate and heat, Constant pressure
    [Rcomp,DELTAHr] = reaction(T,Yc,Pic*Pl); 
    %change order of components
    Rcomp=[Rcomp(:,1),Rcomp(:,2),Rcomp(:,3),Rcomp(:,4),Rcomp(:,5),Rcomp(:,6)];
    end

%calculate cocentration:
Mav=Y*MMASS';
% C=Pl.*Pic./GASCONST./T;

% Cl=C./Cref;
C=Cl*Cref;

Difftermsource=zeros(sum(Ne),6);
if diffmodel==1
    %Calculation of the Sum parts in the WILKE equations:
    sumwrmwrdsr=zeros(N,6);
    sumjrmwrdsr=zeros(N,6);
    for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                     sumwrmwrdsr(k,i)=sumwrmwrdsr(k,i)+Y(k,j)/Diff(i,j)/(1-Y(k,i));
                 end
             end
         end
    end
    
   %Define Ds and Dref
    Ds=1./sumwrmwrdsr;
    Dref=Ds(N,3);
     
 %Calculation of the Sum parts in the MS equations:     
    for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                     sumjrmwrdsr(k,i)=sumjrmwrdsr(k,i)+Dref*Flux(k,j)/Diff(i,j)*Y(k,i);
                 end
             end
         end
    end
  for i=1:6
 Difftermcolloc{i}=Dref./Ds(:,i)./Cl;
 end
 Difftermsource=zeros(sum(Ne),6);
 
elseif diffmodel==2
    %Calculation of the Sum parts in the WILKE-BOS equations:
    sumwrmwrdsr=zeros(N,6);
    sumjrmwrdsr=zeros(N,6);
    for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                     sumwrmwrdsr(k,i)=sumwrmwrdsr(k,i)+Y(k,j)/Diff(i,j)/(1-Y(k,i));
                 end
             end
         end
    end
    
   %Define Ds and Dref
       %knudsen diffusion:
%http://www.springerlink.com/content/3r71012k1u2t2766/
   for i=1:6
    Dk(:,i)=48.5*dpore*(T/MMASS(i)).^0.5*eps/tau;
end 
   
Dim=1./sumwrmwrdsr;
Dsinv=1./Dim+1./Dk;
Ds=1./Dsinv;
Dref=Ds(N,3);
     
 %Calculation of the Sum parts in the MS equations:     
    for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                     sumjrmwrdsr(k,i)=sumjrmwrdsr(k,i)+Dref*Flux(k,j)/Diff(i,j)*Y(k,i);
                 end
             end
         end
    end
  for i=1:6
 Difftermcolloc{i}=Dref./Ds(:,i)./Cl;
 end
 Difftermsource=zeros(sum(Ne),6);
elseif diffmodel==3
%Calculation of the Sum parts in the MS equations:
    sumwrmwrdsr=zeros(N,6);
    sumjrmwrdsr=zeros(N,6);
    for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                     sumwrmwrdsr(k,i)=sumwrmwrdsr(k,i)+Y(k,j)/Diff(i,j);
                 end
             end
         end
    end
    
   %Define Ds and Dref
    Ds=1./sumwrmwrdsr;
    Dref=Ds(N,3);

 %Calculation of the Sum parts in the MS equations:     
    for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                     sumjrmwrdsr(k,i)=sumjrmwrdsr(k,i)+Dref*Flux(k,j)/Diff(i,j)*Y(k,i);
                 end
             end
         end
    end
 for i=1:6
 Difftermcolloc{i}=Dref./Ds(:,i)./Cl;
 end
 for i=1:6
     for E=1:Noe
     Difftermsource(Neb(E):Neb(E+1)-1,i)=Difftermsource(Neb(E):Neb(E+1)-1,i)+sumjrmwrdsr(Nec(E):Nec(E+1),i)./Cl(Nec(E):Nec(E+1));                                                                
     end
  end
elseif diffmodel==4
%knudsen diffusion:
%http://www.springerlink.com/content/3r71012k1u2t2766/
for i=1:6
    Dk(:,i)=48.5*dpore*(T/MMASS(i)).^0.5*eps/tau;
end

%Calculation of the Sum parts in the MS equations:
    sumwrmwrdsr=zeros(N,6);
    sumjrmwrdsr=zeros(N,6);
    for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                     sumwrmwrdsr(k,i)=sumwrmwrdsr(k,i)+Y(k,j)/Diff(i,j);
                 end
             end
             sumwrmwrdsr(k,i)=sumwrmwrdsr(k,i)+1/Dk(k,i);
         end
    end
    
   %Define Ds and Dref
    Ds=1./sumwrmwrdsr;
    Dref=5.3636*10^-7;

       
 %Calculation of the Sum parts in the MS equations:     
    for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                     sumjrmwrdsr(k,i)=sumjrmwrdsr(k,i)+Dref*Flux(k,j)/Diff(i,j)*Y(k,i);
                 end
             end
         end
    end
  for i=1:6
 Difftermcolloc{i}=Dref./Ds(:,i)./Cl;
 end
   for i=1:6
     for E=1:Noe
     Difftermsource(Neb(E):Neb(E+1)-1,i)=Difftermsource(Neb(E):Neb(E+1)-1,i)+sumjrmwrdsr(Nec(E):Nec(E+1),i)./Cl(Nec(E):Nec(E+1))-Y(Nec(E):Nec(E+1),i).*u(Nec(E):Nec(E+1))./Dk(Nec(E):Nec(E+1),i)*Dref;                                                                
     end
  end
end


% convective terms  
% conv velocity

for i=1:N
W(i,:)=Y(i,:).*MMASS./((Y(i,:)*MMASS'));
end 
[VISg, vis_comp] = viscosity(T,W,N); %massfraction


%Calculate molar velocity converted from fluxes:
velconv=zeros(N,1);
 for i=1:6
     velconv=velconv+Flux(:,i)*MMASS(i)./Mav./Cl;
 end
%relaxation needed for the convective term
vconv=velconv+u;
vconv=vconv*CONVswitch;
alpha=0.01;
vconvrelaxed=vconv*alpha+(1-alpha)*vconvrelaxed;

 
 %Calculate average CP for gas:
 CPg = Heat_capacitymol(Y(:,1),Y(:,2),Y(:,3),Y(:,4),Y(:,5),Y(:,6),T);
 %---------
 

 % Dervative matrices for spectral element method.
 TEMPdenum(:,1)=(1-eps)*rhop*CPp+eps.*Cl.*Cref.*CPg;
 TEMPdenumtst(:,1)=(1-eps)*rhop*CPp+eps*Cltst*Cref.*CPgtst;
 for E=1:Noe
    for i=1:6
    Diffmodel{E,i}=diag(Difftermcolloc{i}(Nec(E):Nec(E+1)));
    end
    %temperature equation
    for k=Nec(E):Nec(E+1)
    DtempE{E}(k-Necspace(E),:)=DE{E}(k-Necspace(E),:)*vconvrelaxed(k)*Cl(k)*Cref*CPg(k)/TEMPdenum(k)*tetta*tstep*r(k);
    Dtemp2E{E}(k-Necspace(E),:)=DE{E}(k-Necspace(E),:)./TEMPdenum(k)*lambda/Dref*tstep*tetta*r(k);
    %Species balance
    DSBE{E}(k-Necspace(E),:)=DE{E}(k-Necspace(E),:)*tetta*tstep./Cl(k)*r(k);
        %Convective term species mole balance
    DCvelconvE{E}(k-Necspace(E),:)=DE{E}(k-Necspace(E),:)*u(k)*tetta*tstep*r(k);
    %Molar continuity:
    DCluE{E}(k-Necspace(E),:)=DE{E}(k-Necspace(E),:)*u(k)*tetta*tstep*r(k);
    DCONT2{E}(k-Necspace(E),:)=DE{E}(k-Necspace(E),:)*Cl(k)*tetta*tstep*r(k);    
    end
    Dr{E}=diag(rE{E})*DE{E};
end
 

%relaxation needed for the convective term
alphaCT=1;
for E=1:Noe
DCvelconvRelaxedE{E}=DCvelconvE{E}*alphaCT+(1-alphaCT)*DCvelconvRelaxedE{E};
end
    % Main matrix
    % automatic for elements:
    R=zeros(sum(Ne),ant*sum(Ne),ant);
    Nlsq=sum(Ne);
    for E=1:Noe
        SEEND=zeros(Ne(E),Neb(end)-Neb(E+1));
        SESTART=zeros(Ne(E),Nebspace(E));
R(Neb(E):Neb(E+1)-1,:,1)= R(Neb(E):Neb(E+1)-1,:,1) +[SESTART,DE{E},SEEND,SESTART,diag(ones(Ne(E),1)),SEEND,zeros(Ne(E),Nlsq*(ant-2))];
R(Neb(E):Neb(E+1)-1,:,2)= R(Neb(E):Neb(E+1)-1,:,2) +[SESTART,DtempE{E}+diag(ones(Ne(E),1).*rE{E}),SEEND,SESTART,diag(2.*lambda./Dref./TEMPdenum(Nec(E):Nec(E+1))*tstep*tetta)+Dtemp2E{E},SEEND,zeros(Ne(E),Nlsq*(ant-2))];
R(Neb(E):Neb(E+1)-1,:,3)= R(Neb(E):Neb(E+1)-1,:,3) +[zeros(Ne(E),Nlsq*2),SESTART,DE{E},SEEND,zeros(Ne(E),Nlsq*5),SESTART,Diffmodel{E,1},SEEND,zeros(Ne(E),Nlsq*(ant-9))];
R(Neb(E):Neb(E+1)-1,:,4)= R(Neb(E):Neb(E+1)-1,:,4) +[zeros(Ne(E),Nlsq*3),SESTART,DE{E},SEEND,zeros(Ne(E),Nlsq*5),SESTART,Diffmodel{E,2},SEEND,zeros(Ne(E),Nlsq*(ant-10))];
R(Neb(E):Neb(E+1)-1,:,5)= R(Neb(E):Neb(E+1)-1,:,5) +[zeros(Ne(E),Nlsq*4),SESTART,DE{E},SEEND,zeros(Ne(E),Nlsq*5),SESTART,Diffmodel{E,3},SEEND,zeros(Ne(E),Nlsq*(ant-11))];
R(Neb(E):Neb(E+1)-1,:,6)= R(Neb(E):Neb(E+1)-1,:,6) +[zeros(Ne(E),Nlsq*5),SESTART,DE{E},SEEND,zeros(Ne(E),Nlsq*5),SESTART,Diffmodel{E,4},SEEND,zeros(Ne(E),Nlsq*(ant-12))];
R(Neb(E):Neb(E+1)-1,:,7)= R(Neb(E):Neb(E+1)-1,:,7) +[zeros(Ne(E),Nlsq*6),SESTART,DE{E},SEEND,zeros(Ne(E),Nlsq*5),SESTART,Diffmodel{E,5},SEEND,zeros(Ne(E),Nlsq*(ant-13))];
R(Neb(E):Neb(E+1)-1,:,8)= R(Neb(E):Neb(E+1)-1,:,8) +[zeros(Ne(E),Nlsq*2),SESTART,diag(ones(Ne(E),1)),SEEND,SESTART,diag(ones(Ne(E),1)),SEEND,SESTART,diag(ones(Ne(E),1)),SEEND,SESTART,diag(ones(Ne(E),1)),SEEND,SESTART,diag(ones(Ne(E),1)),SEEND,SESTART,diag(ones(Ne(E),1)),SEEND,zeros(Ne(E),Nlsq*(ant-8))];
R(Neb(E):Neb(E+1)-1,:,9)= R(Neb(E):Neb(E+1)-1,:,9) +[zeros(Ne(E),Nlsq*2),SESTART,DCvelconvRelaxedE{E}+diag(ones(Ne(E),1).*rE{E}),SEEND,zeros(Ne(E),Nlsq*5),SESTART,diag(2./Cl(Nec(E):Nec(E+1))*tstep*tetta)+DSBE{E},SEEND,zeros(Ne(E),Nlsq*(ant-9))];
R(Neb(E):Neb(E+1)-1,:,10)=R(Neb(E):Neb(E+1)-1,:,10)+[zeros(Ne(E),Nlsq*3),SESTART,DCvelconvRelaxedE{E}+diag(ones(Ne(E),1).*rE{E}),SEEND,zeros(Ne(E),Nlsq*5),SESTART,diag(2./Cl(Nec(E):Nec(E+1))*tstep*tetta)+DSBE{E},SEEND,zeros(Ne(E),Nlsq*(ant-10))];
R(Neb(E):Neb(E+1)-1,:,11)=R(Neb(E):Neb(E+1)-1,:,11)+[zeros(Ne(E),Nlsq*4),SESTART,DCvelconvRelaxedE{E}+diag(ones(Ne(E),1).*rE{E}),SEEND,zeros(Ne(E),Nlsq*5),SESTART,diag(2./Cl(Nec(E):Nec(E+1))*tstep*tetta)+DSBE{E},SEEND,zeros(Ne(E),Nlsq*(ant-11))];
R(Neb(E):Neb(E+1)-1,:,12)=R(Neb(E):Neb(E+1)-1,:,12)+[zeros(Ne(E),Nlsq*5),SESTART,DCvelconvRelaxedE{E}+diag(ones(Ne(E),1).*rE{E}),SEEND,zeros(Ne(E),Nlsq*5),SESTART,diag(2./Cl(Nec(E):Nec(E+1))*tstep*tetta)+DSBE{E},SEEND,zeros(Ne(E),Nlsq*(ant-12))];
R(Neb(E):Neb(E+1)-1,:,13)=R(Neb(E):Neb(E+1)-1,:,13)+[zeros(Ne(E),Nlsq*6),SESTART,DCvelconvRelaxedE{E}+diag(ones(Ne(E),1).*rE{E}),SEEND,zeros(Ne(E),Nlsq*5),SESTART,diag(2./Cl(Nec(E):Nec(E+1))*tstep*tetta)+DSBE{E},SEEND,zeros(Ne(E),Nlsq*(ant-13))];
R(Neb(E):Neb(E+1)-1,:,14)=R(Neb(E):Neb(E+1)-1,:,14)+[zeros(Ne(E),Nlsq*8),SESTART,diag(ones(Ne(E),1)),SEEND,SESTART,diag(ones(Ne(E),1)),SEEND,SESTART,diag(ones(Ne(E),1)),SEEND,SESTART,diag(ones(Ne(E),1)),SEEND,SESTART,diag(ones(Ne(E),1)),SEEND,SESTART,diag(ones(Ne(E),1)),SEEND,zeros(Ne(E),Nlsq*(ant-14))];
R(Neb(E):Neb(E+1)-1,:,15)=R(Neb(E):Neb(E+1)-1,:,15)+[zeros(Ne(E),Nlsq*14),SESTART,diag(ones(Ne(E),1)),SEEND,zeros(Ne(E),Nlsq),SESTART,-diag(ones(Ne(E),1)/GASCONST./T(Nec(E):Nec(E+1))/Cref*Pic),SEEND,zeros(Ne(E),Nlsq*(ant-17))];
R(Neb(E):Neb(E+1)-1,:,16)=R(Neb(E):Neb(E+1)-1,:,16)+[zeros(Ne(E),Nlsq*14),SESTART,DCluE{E}+diag(ones(Ne(E),1).*rE{E}),SEEND,SESTART,diag(2.*Cl(Nec(E):Nec(E+1))*tstep*tetta)+DCONT2{E},SEEND,zeros(Ne(E),Nlsq*(ant-16))];
R(Neb(E):Neb(E+1)-1,:,17)=R(Neb(E):Neb(E+1)-1,:,17)+[zeros(Ne(E),Nlsq*16),SESTART,DE{E},SEEND,zeros(Ne(E),Nlsq*(ant-17))];
    end  
    
    
A=zeros(ant*N,ant*N);
     L=[R(:,:,1);R(:,:,2);R(:,:,3);R(:,:,4);R(:,:,5);R(:,:,6);R(:,:,7);R(:,:,8);...
    R(:,:,9);R(:,:,10);R(:,:,11);R(:,:,12);R(:,:,13);R(:,:,14);R(:,:,15);R(:,:,16);R(:,:,17)];
     
     Anonoverlapping=L'*Wmatrix*L;
     %introduce overlap:
     for E=1:Noe
         for i=1:ant
             for j=1:ant
                A((N*(j-1)+Nec(E):N*(j-1)+Nec(E+1)),(N*(i-1)+Nec(E):N*(i-1)+Nec(E+1)))=A((N*(j-1)+Nec(E):N*(j-1)+Nec(E+1)),(N*(i-1)+Nec(E):N*(i-1)+Nec(E+1)))+Anonoverlapping((sum(Ne)*(j-1)+Neb(E):sum(Ne)*(j-1)+Neb(E+1)-1),(sum(Ne)*(i-1)+Neb(E):sum(Ne)*(i-1)+Neb(E+1)-1));
             end
         end 
     end
     
%Boundary conditions in A matrix:
%Q   
% A(N,1:2*N)=zeros(1,2*N);
if Tlswitch==0
    A(N,N)=A(N,N)+1;
elseif Tlswitch==1
    A(N,N)=A(N,N)+h; %T^*
end


%T
% A(N+1,1:2*N)=zeros(1,2*N);
 A(N+1,N+1)=A(N+1,N+1)+1;
    

%MS CH4 CO CO2 H2 N2 
 for i=1:5
%  A((2+i)*N,1:ant*N)=zeros(1,ant*N);
  A((2+i)*N,(2+i)*N)=A((2+i)*N,(2+i)*N)+1;
 end

% molefrac CH4 CO CO2 H2 N2
 for i=1:5
%       A((7+i)*N+1,1:(ant*N))=zeros(1,ant*N);
      A((7+i)*N+1,(7+i)*N+1)=A((7+i)*N+1,(7+i)*N+1)+1;
 end
 

  %Continuity
% A(15*N+1,1:ant*N)=zeros(1,ant*N);
A(15*N+1,15*N+1)=A(15*N+1,15*N+1)+1;
  
  %darcy
% A(17*N,1:ant*N)=zeros(1,ant*N);
A(17*N,17*N)=A(17*N,17*N)+1;


%Boundary conditions in source vector
g=zeros(sum(Ne),ant);

%----------------------------------------



%Teq:
for E=1:Noe
g(Neb(E):Neb(E+1)-1,2)=-DELTAHr(Nec(E):Nec(E+1)).*Rp^2./Tref./Dref*tstep*tetta./TEMPdenum(Nec(E):Nec(E+1)).*rE{E}...
    +tstep*(1-tetta)*(-DELTAHrtst(Nec(E):Nec(E+1))*Rp^2/Dref/Tref.*rE{E}-(Cltst(Nec(E):Nec(E+1))*Cref.*vtst(Nec(E):Nec(E+1)).*CPgtst(Nec(E):Nec(E+1)).*(DE{E}*Ttst(Nec(E):Nec(E+1)))/Tref.*rE{E}+lambda/Dref*(2*qtst(Nec(E):Nec(E+1))+(DE{E}*qtst(Nec(E):Nec(E+1))).*rE{E})))./TEMPdenumtst(Nec(E):Nec(E+1))+Ttst(Nec(E):Nec(E+1))/Tref.*rE{E};
end

% Diffusion model source terms:
for i=1:5
     for E=1:Noe
        g(:,2+i)=Difftermsource(:,i);
     end
 end

%Species balance  CH4 CO CO2 H2 N2 H2O
 for i=1:5
     for E=1:Noe
        g(Neb(E):Neb(E+1)-1,i+8)=(Rcomp(Nec(E):Nec(E+1),i)-sum(Rcomp(Nec(E):Nec(E+1),:)')'.*Y(Nec(E):Nec(E+1),i))*rhop*(1-eps)*Rp^2/Cref./Cl(Nec(E):Nec(E+1))/Dref*tstep*tetta.*rE{E}...
            +tstep*(1-tetta)*((Rcomptst(Nec(E):Nec(E+1),i)-sum(Rcomptst(Nec(E):Nec(E+1),:)')'.*Ytst(Nec(E):Nec(E+1),i))*rhop*(1-eps)*Rp^2/Cref./Cltst(Nec(E):Nec(E+1))/Dref.*rE{E}-(DE{E}*Ytst(Nec(E):Nec(E+1),i).*utst(Nec(E):Nec(E+1)).*rE{E}+2*Fluxtst(Nec(E):Nec(E+1),i)./Cltst(Nec(E):Nec(E+1))+DE{E}*Fluxtst(Nec(E):Nec(E+1),i)./Cltst(Nec(E):Nec(E+1)).*rE{E}))+Ytst(Nec(E):Nec(E+1),i).*rE{E};
     end
 end
%sum fluxes:
g(:,8)=ones(sum(Ne),1);
%sum molfracs:
g(:,14)=zeros(sum(Ne),1);

for E=1:Noe
%Mole base continuity
g(Neb(E):Neb(E+1)-1,16)=sum(Rcomp((Nec(E):Nec(E+1)),:)')'*rhop*(1-eps)*Rp^2/Cref/Dref*tstep*tetta.*rE{E}+...
    tstep*(1-tetta)*(sum(Rcomptst((Nec(E):Nec(E+1)),:)')'*rhop*(1-eps)*Rp^2/Cref/Dref.*rE{E}-(2.*Cltst(Nec(E):Nec(E+1)).*utst(Nec(E):Nec(E+1))+DE{E}*Cltst(Nec(E):Nec(E+1)).*utst(Nec(E):Nec(E+1)).*rE{E}+DE{E}*utst(Nec(E):Nec(E+1)).*Cltst(Nec(E):Nec(E+1)).*rE{E}))...
    +Cltst(Nec(E):Nec(E+1)).*rE{E};

%darcy's law
for E=1:Noe
g(Neb(E):Neb(E+1)-1,17)=-Dref.*VISg(Nec(E):Nec(E+1))./B0./Pic.*vconvrelaxed(Nec(E):Nec(E+1));
end
end

gV=[];
for i=1:ant
    gV=[gV;g(:,i)];
end

Fw=L'*Wmatrix*gV;

% create one seamless source vector:
Fwgt=zeros(N*ant,1);
for I=1:ant
for E=1:Noe
Fwgt(N*(I-1)+Nec(E):N*(I-1)+Nec(E+1),1)=Fwgt(N*(I-1)+Nec(E):N*(I-1)+Nec(E+1),1)+Fw((Neb(E):Neb(E+1)-1)+sum(Ne)*(I-1),1);
end
end

 %Qeq
if Tlswitch==0
    Fwgt(N)=Fwgt(N)+1;
elseif Tlswitch==1
    Fwgt(N)=Fwgt(N)+f(2*N)*lambda/Rp+C(N)*CPg(N)*T(N)/Tref*vconvrelaxed(N)*Dref/Rp+h;
end
 
 Fwgt(N+1)=Fwgt(N+1)+0;
 
 % BC at surface
 if Tlswitch==0
    for i=1:5
    Fwgt((2+i)*N)=Fwgt((2+i)*N)+Yic(i);
    end
elseif Tlswitch==1
    for i=1:5
    Fwgt((2+i)*N)=Fwgt((2+i)*N)+((Flux(N,i)*Dref/Rp+u(N)*Dref/Rp*Cl(N)*Y(N,i))/ki(i)+Yic(i))/Cl(N);
    end
 end
 
 %BC at senter
for i=1:5
Fwgt((7+i)*N+1)=Fwgt((7+i)*N+1)+0;
end

Fwgt(15*N+1)=Fwgt(15*N+1)+0;

Fwgt(17*N)=Fwgt(17*N)+1;


fold=f;

%solve
f=A\Fwgt;

itcount=itcount+1;


% Pulse relaxation:
% Pulse=Pulse+1;
if Pulse>80 && itcount>50
alpha=0.005;
alphaj=0.1;
alphaCl=0.1;
alphaC=1;
alphaP=1;
f(1:N)=alphaj*f(1:N)+(1-alphaj)*fold(1:N);
% f(N+1:2*N)=(alphaj*f(N+1:2*N)+(1-alphaj)*fold(N+1:2*N));
f(2*N+1:8*N)=max(alpha*f(2*N+1:8*N)+(1-alpha)*fold(2*N+1:8*N),0.000000000001);
% f(8*N+1:14*N)=alphaj*f(8*N+1:14*N)+(1-alphaj)*fold(8*N+1:14*N);
f(14*N+1:15*N)=max(alphaCl*f(14*N+1:15*N)+(1-alphaCl)*fold(14*N+1:15*N),0.5);
% f(15*N+1:16*N)=alphaC*f(15*N+1:16*N)+(1-alphaC)*fold(15*N+1:16*N);
% f(16*N+1:17*N)=max(alphaP*f(16*N+1:17*N)+(1-alphaP)*fold(16*N+1:17*N),0.5);
Pulse=1;
else
% relaxation of the iteration:
if t<0.4
alpha=0.005;%8
alphaj=0.1;
else
alpha=0.00025;
alphaj=0.1;
end
alphaCl=1;
alphaC=1;
alphaP=1;
% f(1:N)=alphaj*f(1:N)+(1-alphaj)*fold(1:N);
f(N+1:2*N)=(alphaj*f(N+1:2*N)+(1-alphaj)*fold(N+1:2*N));
f(2*N+1:8*N)=max(alpha*f(2*N+1:8*N)+(1-alpha)*fold(2*N+1:8*N),0.000000000001);
% f(8*N+1:14*N)=alphaj*f(8*N+1:14*N)+(1-alphaj)*fold(8*N+1:14*N);
% f(14*N+1:15*N)=max(alphaCl*f(14*N+1:15*N)+(1-alphaCl)*fold(14*N+1:15*N),0.5);
% f(14*N+1:15*N)=alphaC*f(14*N+1:15*N)+(1-alphaC)*fold(14*N+1:15*N);
% f(16*N+1:17*N)=max(alphaP*f(16*N+1:17*N)+(1-alphaP)*fold(16*N+1:17*N),0.5);
end

%update Molfracs and temperature
Flux=[f(8*N+1:9*N),f(9*N+1:10*N),f(10*N+1:11*N),f(11*N+1:12*N),f(12*N+1:13*N),f(13*N+1:14*N)];
Y=[f(2*N+1:3*N),f(3*N+1:4*N),f(4*N+1:5*N),f(5*N+1:6*N),f(6*N+1:7*N),f(7*N+1:8*N)];
T=f(1:N)*Tref;
Cl=f(14*N+1:15*N);
u=f(15*N+1:16*N);
Pl=f(16*N+1:17*N);


residual=sqrt((A*f-Fwgt)'*diag(WGT)*(A*f-Fwgt))
end
% writeout t point
t
% add solutions for each time step:
ftrans=[ftrans,f];
tpoints=[tpoints,t];

end
r=r*Rp
%plot results
%figure
subplot(3,3,1)
hold on
plot(r,f(N+1:2*N)*Tref,'r')
Y=[f(2*N+1:3*N),f(3*N+1:4*N),f(4*N+1:5*N),f(5*N+1:6*N),f(6*N+1:7*N),f(7*N+1:8*N)];

for i=1:N
    W(i,:)=Y(i,:).*MMASS./((Y(i,:)*MMASS'));
end

    if Comp==1 %H2O
    elseif Comp==2%CH4
        Y=[Y(:,6),Y(:,2),Y(:,3),Y(:,4),Y(:,5),Y(:,1)];
    elseif Comp==3%CO
        Y=[Y(:,1),Y(:,6),Y(:,3),Y(:,4),Y(:,5),Y(:,2)];
    elseif Comp==4%CO2
        Y=[Y(:,1),Y(:,2),Y(:,6),Y(:,4),Y(:,5),Y(:,3)];
    elseif Comp==5%H2
        Y=[Y(:,1),Y(:,2),Y(:,3),Y(:,6),Y(:,5),Y(:,4)];
    elseif Comp==6 %N2
        Y=[Y(:,1),Y(:,2),Y(:,3),Y(:,4),Y(:,6),Y(:,5)];
    end
    
    %writeout residual & error
%Amount of time used on calucation
timespent=toc
sqrt((f-fold)'*diag(WGT)*(f-fold))
residual=sqrt((A*f-Fwgt)'*diag(WGT)*(A*f-Fwgt))
itcount
    
    %save workspace:
    if Comp==1 %H2O
        if Tlswitch==0
            if CONVswitch==0
                if diffmodel==1
                    save('MOLE LSQ TRANSIENT WILKE H2O NOTL NOCONV')
                elseif diffmodel==2
                    save('MOLE LSQ TRANSIENT WILKE-BOS H2O NOTL NOCONV')
                elseif diffmodel==3
                    save('MOLE LSQ TRANSIENT MS H2O NOTL NOCONV')
                elseif diffmodel==4
                    save('MOLE LSQ TRANSIENT Dusty H2O NOTL NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MOLE LSQ TRANSIENT WILKE H2O NOTL')
                elseif diffmodel==2
                    save('MOLE LSQ TRANSIENT WILKE-BOS H2O NOTL')
                elseif diffmodel==3
                    save('MOLE LSQ TRANSIENT MS H2O NOTL')
                elseif diffmodel==4
                    save('MOLE LSQ TRANSIENT Dusty H2O NOTL')
                end
            end
        elseif Tlswitch==1
                        if CONVswitch==0
                if diffmodel==1
                    save('MOLE LSQ TRANSIENT WILKE H2O NOCONV')
                elseif diffmodel==2
                    save('MOLE LSQ TRANSIENT WILKE-BOS H2O NOCONV')
                elseif diffmodel==3
                    save('MOLE LSQ TRANSIENT MS H2O NOCONV')
                elseif diffmodel==4
                    save('MOLE LSQ TRANSIENT Dusty H2O NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MOLE LSQ TRANSIENT WILKE H2O')
                elseif diffmodel==2
                    save('MOLE LSQ TRANSIENT WILKE-BOS H2O')
                elseif diffmodel==3
                    save('MOLE LSQ TRANSIENT MS H2O')
                elseif diffmodel==4
                    save('MOLE LSQ TRANSIENT Dusty H2O')
                end
                        end
        end
                    
    elseif Comp==2%CH4
if Tlswitch==0
            if CONVswitch==0
                if diffmodel==1
                    save('MOLE LSQ TRANSIENT WILKE CH4 NOTL NOCONV')
                elseif diffmodel==2
                    save('MOLE LSQ TRANSIENT WILKE-BOS CH4 NOTL NOCONV')
                elseif diffmodel==3
                    save('MOLE LSQ TRANSIENT MS CH4 NOTL NOCONV')
                elseif diffmodel==4
                    save('MOLE LSQ TRANSIENT Dusty CH4 NOTL NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MOLE LSQ TRANSIENT WILKE CH4 NOTL')
                elseif diffmodel==2
                    save('MOLE LSQ TRANSIENT WILKE-BOS CH4 NOTL')
                elseif diffmodel==3
                    save('MOLE LSQ TRANSIENT MS CH4 NOTL')
                elseif diffmodel==4
                    save('MOLE LSQ TRANSIENT Dusty CH4 NOTL')
                end
            end
        elseif Tlswitch==1
                        if CONVswitch==0
                if diffmodel==1
                    save('MOLE LSQ TRANSIENT WILKE CH4 NOCONV')
                elseif diffmodel==2
                    save('MOLE LSQ TRANSIENT WILKE-BOS CH4 NOCONV')
                elseif diffmodel==3
                    save('MOLE LSQ TRANSIENT MS CH4 NOCONV')
                elseif diffmodel==4
                    save('MOLE LSQ TRANSIENT Dusty CH4 NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MOLE LSQ TRANSIENT WILKE CH4')
                elseif diffmodel==2
                    save('MOLE LSQ TRANSIENT WILKE-BOS CH4')
                elseif diffmodel==3
                    save('MOLE LSQ TRANSIENT MS CH4')
                elseif diffmodel==4
                    save('MOLE LSQ TRANSIENT Dusty CH4')
                end
                        end
        end
       
    elseif Comp==3%CO
if Tlswitch==0
            if CONVswitch==0
                if diffmodel==1
                    save('MOLE LSQ TRANSIENT WILKE CO NOTL NOCONV')
                elseif diffmodel==2
                    save('MOLE LSQ TRANSIENT WILKE-BOS CO NOTL NOCONV')
                elseif diffmodel==3
                    save('MOLE LSQ TRANSIENT MS CO NOTL NOCONV')
                elseif diffmodel==4
                    save('MOLE LSQ TRANSIENT Dusty CO NOTL NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MOLE LSQ TRANSIENT WILKE CO NOTL')
                elseif diffmodel==2
                    save('MOLE LSQ TRANSIENT WILKE-BOS CO NOTL')
                elseif diffmodel==3
                    save('MOLE LSQ TRANSIENT MS CO NOTL')
                elseif diffmodel==4
                    save('MOLE LSQ TRANSIENT Dusty CO NOTL')
                end
            end
        elseif Tlswitch==1
                        if CONVswitch==0
                if diffmodel==1
                    save('MOLE LSQ TRANSIENT WILKE CO NOCONV')
                elseif diffmodel==2
                    save('MOLE LSQ TRANSIENT WILKE-BOS CO NOCONV')
                elseif diffmodel==3
                    save('MOLE LSQ TRANSIENT MS CO NOCONV')
                elseif diffmodel==4
                    save('MOLE LSQ TRANSIENT Dusty CO NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MOLE LSQ TRANSIENT WILKE CO')
                elseif diffmodel==2
                    save('MOLE LSQ TRANSIENT WILKE-BOS CO')
                elseif diffmodel==3
                    save('MOLE LSQ TRANSIENT MS CO')
                elseif diffmodel==4
                    save('MOLE LSQ TRANSIENT Dusty CO')
                end
                        end
        end
    elseif Comp==4%CO2
if Tlswitch==0
            if CONVswitch==0
                if diffmodel==1
                    save('MOLE LSQ TRANSIENT WILKE CO2 NOTL NOCONV')
                elseif diffmodel==2
                    save('MOLE LSQ TRANSIENT WILKE-BOS CO2 NOTL NOCONV')
                elseif diffmodel==3
                    save('MOLE LSQ TRANSIENT MS CO2 NOTL NOCONV')
                elseif diffmodel==4
                    save('MOLE LSQ TRANSIENT Dusty CO2 NOTL NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MOLE LSQ TRANSIENT WILKE CO2 NOTL')
                elseif diffmodel==2
                    save('MOLE LSQ TRANSIENT WILKE-BOS CO2 NOTL')
                elseif diffmodel==3
                    save('MOLE LSQ TRANSIENT MS CO2 NOTL')
                elseif diffmodel==4
                    save('MOLE LSQ TRANSIENT Dusty CO2 NOTL')
                end
            end
        elseif Tlswitch==1
                        if CONVswitch==0
                if diffmodel==1
                    save('MOLE LSQ TRANSIENT WILKE CO2 NOCONV')
                elseif diffmodel==2
                    save('MOLE LSQ TRANSIENT WILKE-BOS CO2 NOCONV')
                elseif diffmodel==3
                    save('MOLE LSQ TRANSIENT MS CO2 NOCONV')
                elseif diffmodel==4
                    save('MOLE LSQ TRANSIENT Dusty CO2 NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MOLE LSQ TRANSIENT WILKE CO2')
                elseif diffmodel==2
                    save('MOLE LSQ TRANSIENT WILKE-BOS CO2')
                elseif diffmodel==3
                    save('MOLE LSQ TRANSIENT MS CO2')
                elseif diffmodel==4
                    save('MOLE LSQ TRANSIENT Dusty CO2')
                end
                        end
        end
    elseif Comp==5%H2
if Tlswitch==0
            if CONVswitch==0
                if diffmodel==1
                    save('MOLE LSQ TRANSIENT WILKE H2 NOTL NOCONV')
                elseif diffmodel==2
                    save('MOLE LSQ TRANSIENT WILKE-BOS H2 NOTL NOCONV')
                elseif diffmodel==3
                    save('MOLE LSQ TRANSIENT MS H2 NOTL NOCONV')
                elseif diffmodel==4
                    save('MOLE LSQ TRANSIENT Dusty H2 NOTL NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MOLE LSQ TRANSIENT WILKE H2 NOTL')
                elseif diffmodel==2
                    save('MOLE LSQ TRANSIENT WILKE-BOS H2 NOTL')
                elseif diffmodel==3
                    save('MOLE LSQ TRANSIENT MS H2 NOTL')
                elseif diffmodel==4
                    save('MOLE LSQ TRANSIENT Dusty H2 NOTL')
                end
            end
        elseif Tlswitch==1
                        if CONVswitch==0
                if diffmodel==1
                    save('MOLE LSQ TRANSIENT WILKE H2 NOCONV')
                elseif diffmodel==2
                    save('MOLE LSQ TRANSIENT WILKE-BOS H2 NOCONV')
                elseif diffmodel==3
                    save('MOLE LSQ TRANSIENT MS H2 NOCONV')
                elseif diffmodel==4
                    save('MOLE LSQ TRANSIENT Dusty H2 NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MOLE LSQ TRANSIENT WILKE H2')
                elseif diffmodel==2
                    save('MOLE LSQ TRANSIENT WILKE-BOS H2')
                elseif diffmodel==3
                    save('MOLE LSQ TRANSIENT MS H2')
                elseif diffmodel==4
                    save('MOLE LSQ TRANSIENT Dusty H2')
                end
                        end
        end
    elseif Comp==6 %N2
if Tlswitch==0
            if CONVswitch==0
                if diffmodel==1
                    save('MOLE LSQ TRANSIENT WILKE N2 NOTL NOCONV')
                elseif diffmodel==2
                    save('MOLE LSQ TRANSIENT WILKE-BOS N2 NOTL NOCONV')
                elseif diffmodel==3
                    save('MOLE LSQ TRANSIENT MS N2 NOTL NOCONV')
                elseif diffmodel==4
                    save('MOLE LSQ TRANSIENT Dusty N2 NOTL NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MOLE LSQ TRANSIENT WILKE N2 NOTL')
                elseif diffmodel==2
                    save('MOLE LSQ TRANSIENT WILKE-BOS N2 NOTL')
                elseif diffmodel==3
                    save('MOLE LSQ TRANSIENT MS N2 NOTL')
                elseif diffmodel==4
                    save('MOLE LSQ TRANSIENT Dusty N2 NOTL')
                end
            end
        elseif Tlswitch==1
                        if CONVswitch==0
                if diffmodel==1
                    save('MOLE LSQ TRANSIENT WILKE N2 NOCONV')
                elseif diffmodel==2
                    save('MOLE LSQ TRANSIENT WILKE-BOS N2 NOCONV')
                elseif diffmodel==3
                    save('MOLE LSQ TRANSIENT MS N2 NOCONV')
                elseif diffmodel==4
                    save('MOLE LSQ TRANSIENT Dusty N2 NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MOLE LSQ TRANSIENT WILKE N2')
                elseif diffmodel==2
                    save('MOLE LSQ TRANSIENT WILKE-BOS N2')
                elseif diffmodel==3
                    save('MOLE LSQ TRANSIENT MS N2')
                elseif diffmodel==4
                    save('MOLE LSQ TRANSIENT Dusty N2')
                end
                        end
        end
    end
end
end
end
end
 


