tplot=tpoints*Rp^2/Dref
fig
screen_size = get(0, 'ScreenSize');
f1 = figure(1);
set(f1, 'Position', [1 4 30 16.875 ] );
subaxis(3,3,1,'SpacingVert',0.12,'SpacingHoriz',0.08,'MarginRight',0.02,'MarginLeft',0.071,'MarginTop',0.05,'MarginBottom',0.07);
% hold on
surf(tplot,r,ftransXf(((0)*Npoints+1:(1)*Npoints),:)*Tref)
for i=1:2
subaxis(3,3,1+i);
% hold on
surf(tplot,r,ftransXf(((1+i)*Npoints+1:(2+i)*Npoints),:))
end

for i=3:5
subaxis(3,3,1+i);
% hold on
surf(tplot,r,ftransXf(((1+i)*Npoints+1:(2+i)*Npoints),:))
end

for i=6:6
subaxis(3,3,1+i);
% hold on
surf(tplot,r,ftransXf(((1+i)*Npoints+1:(2+i)*Npoints),:))
end
i=7
subaxis(3,3,8);
% hold on
surf(tplot,r,ftransXf(((7+i)*Npoints+1:(8+i)*Npoints),:)*Dref/Rp)
subaxis(3,3,9);
i=8
surf(tplot,r,ftransXf(((7+i)*Npoints+1:(8+i)*Npoints),:)*Pic)

%legends
subaxis(3,3,1);
box off
title('Temperature')
xlabel('Time[s]')
ylabel('Position in particle[m]')
zlabel('Temperature[K]')
colorbar
xlim([0 140])
subaxis(3,3,2);
box off
title('CH4')
xlabel('Time[s]')
ylabel('Position in particle[m]')
zlabel('Mole fraction[-]')
colorbar
xlim([0 140])
subaxis(3,3,3);
box off
title('CO')
xlabel('Time[s]')
ylabel('Position in particle[m]')
zlabel('Mole fraction[-]')
colorbar
xlim([0 140])
subaxis(3,3,4);
box off
title('CO2')
xlabel('Time[s]')
ylabel('Position in particle[m]')
zlabel('Mole fraction[-]')
colorbar
xlim([0 140])
subaxis(3,3,5);
box off
title('H2')
xlabel('Time[s]')
ylabel('Position in particle[m]')
zlabel('Mole fraction[-]')
colorbar
xlim([0 140])
subaxis(3,3,6);
box off
title('N2')
xlabel('Time[s]')
ylabel('Position in particle[m]')
zlabel('Mole fraction[-]')
colorbar
xlim([0 140])
subaxis(3,3,7);
box off
title('H2O')
zlabel('Mole fraction[-]')
ylabel('Position in particle[m]')
xlabel('Time[s]')
colorbar
xlim([0 140])
subaxis(3,3,8);
box off
title('Mass av. velocity')
xlabel('Time[s]')
ylabel('Position in particle[m]')
zlabel('Velocity[m/s]')
colorbar
xlim([0 140])
subaxis(3,3,9);
box off
title('Pressure, Pascal')
xlabel('Time[s]')
ylabel('Position in particle[m]')
zlabel('Velocity[m/s]')
colorbar
xlim([0 140])