clear all
clc
ant=1;
% N=200
    %ELEMENT ROUTINE:
Noe=1; %5 5 7 13 case 3
for i=1:Noe
    Ne(i)=200;
    Length(i)=1/Noe;
end
sum(Length)

StartE=zeros(Noe,1);
for i=2:Noe
    StartE(i)=StartE(i-1)+Length(i-1);
end

for i=1:Noe
[rE{i} DE{i} BDE{i} qE{i}] = colloc(Ne(i)-2,1,1);
%mapping
rE{i}=rE{i}*Length(i)+StartE(i);
DE{i}=DE{i}/Length(i);
qE{i}=qE{i}*Length(i);
end
%total number of points:
Npoints=sum(Ne)-max(size(Ne))+1;
N=Npoints
pause
%cumulative addition of elements:
Nec=ones(Noe+1,1);
Nec(2)=Ne(1);
for i=2:Noe
    Nec(i+1)=Nec(i)+Ne(i)-1;
end
Necspace=Nec-1;
% r vector for solution:
r=zeros(N,1);
for E=1:Noe
r(Nec(E):Nec(E+1))=rE{E};
end

%define weights for error calculation:
w=[];
for i=1:ant
    we=zeros(N,1);
    for E=1:Noe
    we(Nec(E):Nec(E+1))=we(Nec(E):Nec(E+1))+qE{E};
    end
    w=[w;we];
end



tol=1*10^-15;
tetta=0.5;
tstep=1*10^-3;
t=0;
v=1
rhotst=0.1*ones(N,1);
rhotst(1)=1;
residual=1
f=ones(N,1);
figure
while t<0.25
   t=t+tstep;
   residual=1;
while residual>tol %&& itcount <250
%Setup problem matrix    
    R=zeros(N,ant*N,ant);
    for E=1:Noe
        %initspace=zeros(Ne(i),Necspace(i));
        SEEND=zeros(Ne(E),Nec(end)-Nec(E+1));
        SESTART=zeros(Ne(E),Necspace(E));
        R(Nec(E):Nec(E+1),:,1)=R(Nec(E):Nec(E+1),:,1)+[SESTART,diag(ones(Ne(E),1))+DE{E}*v*tstep*tetta,SEEND];
    end  
    
     A=[R(:,:,1)]; 
 
     %boundary condition problem matrix
 A(1,:)=zeros(1,N);
 A(1,1)=1;

 %setup source vector:
F=zeros(N*ant,1);
for E=1:Noe
F(Nec(E):Nec(E+1))=F(Nec(E):Nec(E+1))-tstep*(1-tetta)*DE{E}*rhotst(Nec(E):Nec(E+1))*v+rhotst(Nec(E):Nec(E+1));
end
%boundary condition source vector:
F(1)=1;


%solve
f=A\F;
residual=sqrt((A*f-F)'*diag(w)*(A*f-F))

end
plot(r,f);
xlim([0 1]) 
% M(frame)=getframe
gif_add_frame(gca,'CollocExplisittEULER.gif',30);
% pause
rhotst=f(1:N);
end