subaxis(3,3,1,'Spacing', 0.02, 'Padding', 0.036, 'Margin', 0);
hold on
plot(r,f(N+1:2*N)*Tref,'r')
for i=1:2
subaxis(3,3,1+i,'Spacing', 0.02, 'Padding', 0.036, 'Margin', 0);
hold on
plot(r,Y(:,i),'r')
end

for i=3:5
subaxis(3,3,1+i,'Spacing', 0.02, 'Padding', 0.036, 'Margin', 0, 'MarginBottom',.005);
hold on
plot(r,Y(:,i),'r')
end
subaxis(3,3,8,'Spacing', 0.02, 'Padding', 0.036, 'Margin', 0, 'MarginBottom',.01);
hold on
plot(r,vconv*Dref/Rp,'r')
subaxis(3,3,9,'Spacing', 0.02, 'Padding', 0.036, 'Margin', 0, 'MarginBottom',.01);
hold on
plot(r,u*Dref/Rp,'r')

for i=6:6
subaxis(3,3,1+i,'Spacing', 0.02, 'Padding', 0.036, 'Margin', 0, 'MarginBottom',.01);
hold on
plot(r,Y(:,i),'r')
end

%legends
subaxis(3,3,1,'Spacing', 0.02, 'Padding', 0.036, 'Margin', 0);
box off
title('Temperature')
xlabel('Position in particle[m]')
ylabel('Temperature[K]')
subaxis(3,3,2,'Spacing', 0.02, 'Padding', 0.036, 'Margin', 0);
box off
title('CH4')
xlabel('Position in particle[m]')
ylabel('Molefraction[-]')
subaxis(3,3,3,'Spacing', 0.02, 'Padding', 0.036, 'Margin', 0);
box off
title('CO')
xlabel('Position in particle[m]')
ylabel('Molefraction[-]')
subaxis(3,3,4,'Spacing', 0.02, 'Padding', 0.036, 'Margin', 0, 'MarginBottom',.005);
box off
title('CO2')
xlabel('Position in particle[m]')
ylabel('Molefraction[-]')
subaxis(3,3,5,'Spacing', 0.02, 'Padding', 0.036, 'Margin', 0, 'MarginBottom',.005);
box off
title('H2')
xlabel('Position in particle[m]')
ylabel('Molefraction[-]')
subaxis(3,3,6,'Spacing', 0.02, 'Padding', 0.036, 'Margin', 0, 'MarginBottom',.005);
box off
title('N2')
xlabel('Position in particle[m]')
ylabel('Molefraction[-]')
subaxis(3,3,7,'Spacing', 0.02, 'Padding', 0.036, 'Margin', 0, 'MarginBottom',.01);
box off
title('H2O')
xlabel('Position in particle[m]')
ylabel('Molefraction[-]')
subaxis(3,3,8,'Spacing', 0.02, 'Padding', 0.036, 'Margin', 0, 'MarginBottom',.01);
box off
title('Mass averaged velocity')
xlabel('Position in particle[m]')
ylabel('Velocity[m/s]')
subaxis(3,3,9,'Spacing', 0.02, 'Padding', 0.036, 'Margin', 0, 'MarginBottom',.01);
box off
title('Mole averaged velocity')
xlabel('Position in particle[m]')
ylabel('Velocity[m/s]')